/*
	File:		MathComponentPrivate.h

	Contains:	Private header file for math component routines.

	Written by:	Gary Woodcock

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_MATHCOMPONENTPRIVATE_
#define	_MATHCOMPONENTPRIVATE_

#include <QuickTimeComponents.h>
#include "DebugFlags.h"

//-----------------------------------------------------------------------
// Private constants

// Maximum number of instances that can be opened
enum
{
	kMaxMathInstances = 3	
};

// Component and interface revision levels
enum
{
	mathInterfaceRevision = 0x00010001	
};

enum
{
	kGenericError = -1L					// Handy return code
};

//-----------------------------------------------------------------------
// Private types

typedef	struct	PrivateGlobals
{
	Component			self;						// Our component ID
	ComponentInstance	capturingComponentInstance;	// Capturing component instance
	Component			delegateComponent;			// Delegate component ID
	ComponentInstance	delegateComponentInstance;	// Delegate component instance
	short				resRefNum;					// Our resource refNum
}
PrivateGlobals, *PrivateGlobalsPtr, **PrivateGlobalsHdl;

//-----------------------------------------------------------------------
// Private prototypes

#ifdef DEBUG_IT

// Only need this prototype if we're running linked (for debugging)
pascal	ComponentResult	MathDispatcher	(ComponentParameters	*params,
										 Handle					storage);
										 
#endif DEBUG_IT
											 
//-----------------------------------------------------------------------

#endif	_MATHCOMPONENTPRIVATE_

//-----------------------------------------------------------------------
