/*
	File:		NuMathComponentPrivate.h

	Contains:	Private header file for NuMath component routines.

	Written by:	Gary Woodcock

	Copyright:	 1992 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_NUMATHCOMPONENTPRIVATE_
#define	_NUMATHCOMPONENTPRIVATE_

#include <QuickTimeComponents.h>
#include "DebugFlags.h"

//-----------------------------------------------------------------------
// Private constants

// Maximum number of instances that can be opened
enum
{
	kMaxNuMathInstances = 1	
};

// Component and interface revision levels
enum
{
	nuMathInterfaceRevision = 0x00010001	
};


//-----------------------------------------------------------------------
// Private prototypes

#ifdef DEBUG_IT

// Only need this prototype if we're running linked (for debugging)
pascal	ComponentResult	NuMathDispatcher	(ComponentParameters	*params,
											 Handle					storage);

#endif DEBUG_IT
											 
pascal	ComponentResult	_NuMathOpen			(Handle					storage,
											 ComponentInstance		self);

pascal	ComponentResult	_NuMathClose		(Handle					storage,
											 ComponentInstance		self);

pascal	ComponentResult	_NuMathCanDo		(short					selector);

pascal	ComponentResult	_NuMathVersion		(void);

pascal	ComponentResult	_NuMathRegister		(void);
	
pascal	ComponentResult	_NuMathDoDivide		(short					numerator,
											 short					denominator,
											 short					*quotient);
											 
pascal	ComponentResult	_NuMathDoMultiply	(Handle					storage,
										 	 short					firstNum,
											 short					secondNum,
											 short					*multiplicationResult);

//-----------------------------------------------------------------------

#endif	_NUMATHCOMPONENTPRIVATE_

//-----------------------------------------------------------------------
