//--------------------------------------------------------------------------
//
//		MyUtilities.c
//			by John Wang
//
//		Version:	1.0		02/25/93	Completed.
//
//--------------------------------------------------------------------------

#include	"MyUtilities.h"

//--------------------------------------------------------------------------

void HexToString(short val, char *str)
{
	short		digit;
	
	if ((digit = ((val >> 12) & 0x0F)) > 9)
		str[0] =  digit + 'A' - 10;
	else
		str[0] =  digit + '0';

	if ((digit = ((val >> 8) & 0x0F)) > 9)
		str[1] =  digit + 'A' - 10;
	else
		str[1] =  digit + '0';

	if ((digit = ((val >> 4) & 0x0F)) > 9)
		str[2] =  digit + 'A' - 10;
	else
		str[2] =  digit + '0';

	if ((digit = ((val) & 0x0F)) > 9)
		str[3] =  digit + 'A' - 10;
	else
		str[3] =  digit + '0';
}


void LongToString(long val, char *str)
{
	short		index;
	long		digit;
	
	index = 0;
	if (val<0) {
		str[index++] = '-';
		val = -val;
	}
	for (digit=1000000000; digit>1 && val<digit; digit /= 10);	//	Find first digit and start from there.
	for (; digit>0; digit /= 10) {
		str[index++] = val / digit + '0';
		val %= digit;
	}
}

