/*
	File:		CurlyPrivate.h

	Contains:	Private header file for Curly component routines.

				Refer to develop Issue 15, "Managing Component Registration",
				for details on this code.

	Written by:	Gary Woodcock

	Copyright:	 1993 by Apple Computer, Inc.

	Change History (most recent first):

*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_CURLYPRIVATE_
#define	_CURLYPRIVATE_

#include "CompileFlags.h"

#include <Components.h>

//-----------------------------------------------------------------------
// Private constants

// Base resource ID
enum
{
	kCurlyBaseResID = 400
};

// Maximum number of instances that can be opened
enum
{
	kMaxCurlyInstances = 1
};

// Component and interface revision levels
enum
{
	curlyInterfaceRev = 0x00010001	
};

//-----------------------------------------------------------------------
// Private types

typedef	struct CurlyPrivateGlobals
{
	Component	self;	// Component ID
}
CurlyPrivateGlobals, *CurlyPrivateGlobalsPtr, **CurlyPrivateGlobalsHdl;

//-----------------------------------------------------------------------
// Private prototypes

#ifdef BUILD_LINKED

// Only need this prototype if we're running linked (for debugging)
pascal ComponentResult
CurlyDispatcher (ComponentParameters *params, Handle storage);
										 
#endif BUILD_LINKED
											 
pascal ComponentResult
_CurlyOpen (Handle storage, ComponentInstance self);
	
pascal ComponentResult
_CurlyClose (Handle storage, ComponentInstance self);

pascal ComponentResult
_CurlyCanDo (short selector);

pascal ComponentResult
_CurlyVersion (void);

pascal ComponentResult
_CurlyRegister (void);

#ifdef THINK_C
#ifdef BUILD_LINKED

Component
RegisterCurly (void);

#endif BUILD_LINKED
#endif THINK_C

//-----------------------------------------------------------------------

#endif _CURLYPRIVATE_

//-----------------------------------------------------------------------
