//	Copyright:	 1992 by Apple Computer, Inc.

/*
	This file contains all of the prototypes for the Inside Macintosh
	Movie Toolbox Example code.
 */

#include <fonts.h>
#include <quickdraw.h>
#include <gestaltequ.h>
#include <script.h>
#include <packages.h>
#include <resources.h>
#include <sound.h>
#include <toolutils.h>

#include <imagecompression.h>
#include <movies.h>

Boolean			IsQuickTimeInstalled(void);
Movie			GetMovie(void);
void			CheckError(OSErr error, Str255 displayString);

void			InitMovieToolbox(void);
void			CreateMyCoolMovie(void);
void			CreateMyVideoTrack(Movie theMovie);
void			AddVideoSamplesToMedia(Media theMedia, const Rect *trackFrame);
void			DrawFrame(const Rect *trackFrame, long curSample);
void			CreateMySoundTrack(Movie theMovie);
void			CreateSoundDescription(Handle sndHandle, SoundDescriptionHandle sndDesc, 
					long *sndDataOffset, long *numSamples, long *sndDataSize);
long			GetSndHdrOffset(Handle sndHandle);

void			DoUpdate(WindowPtr theWindow, Movie theMovie);

pascal OSErr	MyCoverProc(Movie aMovie, RgnHandle changedRgn, long refcon);
pascal OSErr	MyUnCoverProc(Movie aMovie, RgnHandle changedRgn, long refcon);
void			InitCoverProcs(WindowPtr aWindow, Movie aMovie);

void			CreateTrackMatte(Track theTrack);
void			UpdateTrackMatte(Track theTrack);
