/*
	File:		MewLaw.r

	Contains:	Sample sound decompression component resources

	Written by:	Kip Olson

	Copyright:	 1994 by Apple Computer, Inc.
*/

#define UseExtendedThingResource	1					// we are going to use the extended component resource

#include "SysTypes.r"
#include "Types.r"

#define MewLawVersion		0x00010000					// version of MewLaw component
#define MewLawComponentID	128							// resource ID for MewLaw component

#define k8BitRawIn			(1 << 0)					// component description flags
#define k8BitTwosIn			(1 << 1)
#define k16BitIn			(1 << 2)
#define kStereoIn			(1 << 3)

#define k8BitRawOut			(1 << 8)
#define k8BitTwosOut		(1 << 9)
#define k16BitOut			(1 << 10)
#define kStereoOut			(1 << 11)

resource 'thng' (MewLawComponentID, purgeable) {		// component resource
	'sdec',												// sound output component type
	'ULAW',												// subtype of this component
	'appl',												// manufacturer
	cmpWantsRegisterMessage | k16BitIn|kStereoIn | k8BitRawOut|k16BitOut|kStereoOut, // component flags
	kAnyComponentFlagsMask,								// component flags mask
	'proc',	MewLawComponentID,							// code resource
	'STR ',	MewLawComponentID,							// component name
	'STR ',	MewLawComponentID+1,						// component description
	'ICON',	MewLawComponentID,							// component icon
	MewLawVersion,										// component version
	componentDoAutoVersion,								// registration flags
	0,													// icon family ID
	{	/* array ComponentPlatformInfo: 0 elements */	// platform
	}
};

resource 'STR ' (MewLawComponentID, purgeable) {		// component name
	"Law 2:1"
};

resource 'STR ' (MewLawComponentID+1, purgeable) {		// component description
	"Converts Law compressed data into 16-bit linear samples."
};

resource 'ICON' (MewLawComponentID, purgeable) {		// component icon
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 01C0 0000"
	$"0780 0000 0E00 0480 0C00 06C0 0C00 07C0"
	$"0E00 0FE0 07FF FFE0 07FF FFE0 03FF FFC0"
	$"03FF FF00 03FF FE00 03FF FE00 07FF FE00"
	$"0770 FE00 0E70 E700 0E70 E700 0738 7380"
};

resource 'vers' (1) {									// Finder version info
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"MewLaw 1.0",
	"MewLaw 1.0\n 1994 Apple Computer, Inc."
};
