/*
	File:		NoiseMaker.r

	Contains:	Sample sound output component resources

	Written by:	Kip Olson

	Copyright:	 1994 by Apple Computer, Inc.
*/

#define UseExtendedThingResource	1					// we are going to use the extended component resource

#include "SysTypes.r"
#include "Types.r"

#define NoiseMakerVersion		0x00010000				// version of NoiseMaker component
#define NoiseMakerComponentID	128						// resource ID for NoiseMaker component


resource 'thng' (NoiseMakerComponentID, purgeable) {	// component resource
	'sdev',												// sound output component type
	'NOIS',												// subtype of this component
	'appl',												// manufacturer
	cmpWantsRegisterMessage, kAnyComponentFlagsMask,	// component flags
	'proc',	NoiseMakerComponentID,						// code resource
	'STR ',	NoiseMakerComponentID,						// component name
	'STR ',	NoiseMakerComponentID+1,					// component description
	'ICON',	NoiseMakerComponentID,						// component icon
	NoiseMakerVersion,									// component version
	componentDoAutoVersion,								// registration flags
	0,													// icon family ID
	{	/* array ComponentPlatformInfo: 0 elements */	// platform
	}
};

resource 'STR ' (NoiseMakerComponentID, purgeable) {	// component name
	"NoiseMaker"
};

resource 'STR ' (NoiseMakerComponentID+1, purgeable) {	// component description
	"NoiseMaker -- an example sound output component."
};

resource 'ICON' (NoiseMakerComponentID, purgeable) {	// component icon
	$"0000 0000 0000 0000 0000 0000 0000 0300"
	$"0000 0480 0000 0900 0000 1080 0000 2040"
	$"0000 2120 0000 4118 0000 400C 0000 800C"
	$"0001 0078 0003 0360 0007 04A3 000E 0460"
	$"001E 3804 003C 3812 1878 3810 2484 1800"
	$"4904 0800 5104 8800 5204 8800 5224 8800"
	$"5424 8800 4824 8800 4022 C400 2041 2200"
	$"1FFE 1C"
};

resource 'vers' (1) {									// Finder version info
	0x1,
	0x0,
	release,
	0x0,
	verUS,
	"NoiseMaker 1.0",
	"NoiseMaker 1.0\n 1994 Apple Computer, Inc."
};
